Add support for mirrors

diff --git a/update.sh b/update.sh
index 209e672..22178ab 100755
--- a/update.sh
+++ b/update.sh
@@ -9,14 +9,32 @@
 NC='\033[0m' # No Color
 
 repo="https://f-droid.org/repo/"
+repo2="https://bubu1.eu/fdroid/repo/"
+repo3="https://fdroid.tetaneutral.net/fdroid/repo/"
+repo4="https://mirror.cyberbits.eu/fdroid/repo/"
+repo5="https://ftp.fau.de/fdroid/repo/"
+repo6="https://ftp.osuosl.org/pub/fdroid/repo/"
+repo7="https://mirror.scd31.com/fdroid/repo/"
+repo8="https://plug-mirror.rcac.purdue.edu/fdroid/repo/"
+repo9="https://mirrors.tuna.tsinghua.edu.cn/fdroid/repo/"
+repo10="https://mirrors.nju.edu.cn/fdroid/repo/"
+repo11="https://mirror.kumi.systems/fdroid/repo/"
+repo12="https://ftp.lysator.liu.se/pub/fdroid/repo/"
+repo13="https://mirror.librelabucm.org/fdroid/repo/"
+
+microg="https://microg.org/fdroid/repo"
+microg_dir="tmp/microg"
+
+nanolx="https://nanolx.org/fdroid/repo"
+nanolx_dir="tmp/nanolx"
 
 # Device type selection	
 PS3='Which device type do you plan on building?: '
-echo -e ${CL_CYN}"(default is 'ABI:x86_64 & ABI2:x86')"
+echo -e ${YELLOW}"(default is 'ABI:x86_64 & ABI2:x86')"
 TMOUT=10
 options=("ABI:x86_64 & ABI2:x86"
 		 "ABI:arm64-v8a & ABI2:armeabi-v7a")
-echo "Timeout in $TMOUT sec."${CL_RST}
+echo -e "Timeout in $TMOUT sec."${NC}
 select opt in "${options[@]}"
 do
 	case $opt in
@@ -94,8 +112,35 @@
     oldRepo="$repo"
 	if [ ! -f tmp/index.xml ];then
 		#TODO: Check security keys
-		wget --connect-timeout=10 $repo/index.jar -O tmp/index.jar
-		unzip -p tmp/index.jar index.xml > tmp/index.xml
+		failed_count=0
+		array=( $repo $repo2 $repo3 $repo4 $repo5 $repo6 $repo7 $repo8 $repo9 $repo10 $repo11 $repo12 $repo13 )
+		for url in $repo $repo2 $repo3 $repo4 $repo5 $repo6 $repo7 $repo8 $repo9 $repo10 $repo11 $repo12 $repo13 ; do
+			echo -e "${GREEN}# Trying: $url ${NC}"
+			if wget --connect-timeout=10 --tries=2 ${url}index.jar -O tmp/index.jar; then
+				unzip -p tmp/index.jar index.xml > tmp/index.xml
+				echo -e "${GREEN}# Downloaded from $url ${NC}"
+				failed=
+				repo=${url}
+				passed=true
+				break
+			elif [ "$failed" ]; then
+				echo -e "${YELLOW}# $url broken ${NC}"
+				failed=true
+				failed_count=$((failed_count+1))
+			else
+				echo -e "${YELLOW}# $url failed ${NC}"
+				failed=true
+				failed_count=$((failed_count+1))
+			fi
+			
+		done
+		echo -e "${Yellow}# Total mirrors: ${#array[@]} ${NC}"
+		echo -e "${RED}# Failed $failed_count mirrors ${NC}"
+		if [ "$failed_count" == "${#array[@]}" ]; then
+			echo -e "${RED}# Failed too many mirrors: $failed_count ${NC}"
+			exit
+			
+		fi
 	fi
 	
 	index=1
@@ -151,6 +196,34 @@
 	addCopy $apk $1 "$2"
 }
 
+downloadStuff() {
+	    what="$1"
+		where="$2"
+		
+		while ! wget --connect-timeout=10 --tries=2 "$what" -O "$where";do sleep 1;done
+}
+
+#downloadFromRepo repo repo_dir packageName overrides
+downloadFromRepo() {
+		repo="$1"
+		repo_dir="$2"
+		package="$3"
+		overrides="$4"
+				
+		mkdir -p "$repo_dir"
+	if [ ! -f "$repo_dir"/index.xml ];then
+		downloadStuff "$repo"/index.jar "$repo_dir"/index.jar
+		unzip -p "$repo_dir"/index.jar index.xml > "$repo_dir"/index.xml
+	fi
+	
+		marketvercode="$(xmlstarlet sel -t -m '//application[id="'"$package"'"]' -v ./marketvercode "$repo_dir"/index.xml || true)"
+		apk="$(xmlstarlet sel -t -m '//application[id="'"$package"'"]/package[versioncode="'"$marketvercode"'"]' -v ./apkname "$repo_dir"/index.xml || xmlstarlet sel -t -m '//application[id="'"$package"'"]/package[1]' -v ./apkname "$repo_dir"/index.xml)"
+		downloadStuff "$repo"/"$apk" bin/"$apk"
+
+		addCopy "$apk" "$package" "$overrides"
+}
+
+
 echo -e "${YELLOW}# grabbing F-Droid Apps${NC}"
 # Terminal Emulator
 downloadFromFdroid com.termoneplus
@@ -207,15 +280,13 @@
 #~ downloadFromFdroid com.keylesspalace.tusky
 
 echo -e "${YELLOW}# grabbing MicroG Apps${NC}"
-repo=https://microg.org/fdroid/repo/
-downloadFromFdroid com.google.android.gms
-downloadFromFdroid com.google.android.gsf
-downloadFromFdroid com.android.vending
-downloadFromFdroid org.microg.gms.droidguard
+downloadFromRepo "$microg" "$microg_dir" com.google.android.gms
+downloadFromRepo "$microg" "$microg_dir" com.google.android.gsf
+downloadFromRepo "$microg" "$microg_dir" com.android.vending "Google Play Store"
+downloadFromRepo "$microg" "$microg_dir" org.microg.gms.droidguard
 
 echo -e "${YELLOW}# grabbing NanoLX Apps${NC}"
-repo=https://nanolx.org/fdroid/repo/
-downloadFromFdroid is.xyz.mpv
+downloadFromRepo "$nanolx" "$nanolx_dir" is.xyz.mpv
 
 echo -e "${LT_BLUE}# finishing up apps.mk${NC}"
 echo >> apps.mk